﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using IGDocumentsSample.Models;
using System.IO;
using Microsoft.Net.Http.Headers;
using Microsoft.AspNetCore.Http;


using Infragistics.Documents.Excel;

namespace IGDocumentsSample.Controllers
{
    public class HomeController : Controller
    {
        private readonly ILogger<HomeController> _logger;

        public HomeController(ILogger<HomeController> logger)
        {
            _logger = logger;
        }

        public IActionResult Index()
        {
            return View();
        }

        public IActionResult Privacy()
        {
            return View();
        }

        public IActionResult Upload()
        {
            return View();
        }


        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }

        public FileContentResult DownloadExcel()
        {
            var stream = new MemoryStream();
            Workbook wb = CreateExcelWorkbook();
            wb.Save(stream);
            return File(stream.ToArray(), "application/xlsx", "sample.xlsx");
        }

        /// <summary>
        /// Excelワークブックを作成します。
        /// </summary>
        /// <returns>Excelワークブック</returns>
        private Workbook CreateExcelWorkbook()
        {
            Workbook workbook = new Workbook(WorkbookFormat.Excel2007);
            Worksheet ws = workbook.Worksheets.Add("サンプルシート");

            // 1行目
            ws.Rows[0].Cells[0].Value = "A";
            ws.Rows[0].Cells[1].Value = "B";
            ws.Rows[0].Cells[2].Value = "C";

            // 2行目
            ws.Rows[1].Cells[0].Value = 123;
            ws.Rows[1].Cells[1].Value = 456;
            ws.Rows[1].Cells[2].Value = 789;

            // 3行目
            ws.Rows[2].Cells[0].Value = 54;
            ws.Rows[2].Cells[1].Value = 154;
            ws.Rows[2].Cells[2].Value = 24;

            return workbook;
        }

        /// <summary>
        /// アップロードされたエクセルファイルを更新し、エクセルファイルを返却します。
        /// </summary>
        /// <param name="TargetFiles"></param>
        /// <returns></returns>
        public FileContentResult UploadExcelFile(List<IFormFile> TargetFiles)
        {
            Stream excelStream = TargetFiles[0].OpenReadStream();
            Workbook workbook = Workbook.Load(excelStream);


            Worksheet ws = workbook.Worksheets[0];

            // セルの読込
            Debug.WriteLine("A1セルの内容:" + ws.Rows[0].Cells[0].Value);

            // セルの更新
            ws.Rows[0].Cells[0].Value = "更新しました。";


            // 更新後のエクセルをダウンロード
            var stream = new MemoryStream();
            workbook.Save(stream);
            return File(stream.ToArray(), "application/xlsx", "sample.xlsx");
        }
    }
}
